<template>
  <v-container>
    <h2 class="display-1">Список тестов</h2>
    <template v-if="tests.length > 0">
      <v-data-table :headers="headers" :items="tests">
        <template #item.author=" { item }">
          {{ item.author.name }}
        </template>
        <template #item.questionCount=" { item }">
          {{ item.questions.length }}
        </template>
        <template #item.link=" { item }">
          <v-btn @click="getLink(item._id)" color="success" x-small
            >Ссылка</v-btn
          >
        </template>
        <template #item.result=" { item }">
          <v-btn :to="`/test/${item._id}/result`" color="info" x-small
            >Результаты</v-btn
          >
        </template>
        <template #item.edit=" { item }">
          <v-btn color="purple" @click="editTest(item._id)" x-small
            >Редактировать</v-btn
          >
        </template>
        <template #item.delete=" { item }">
          <v-btn color="error" @click="deleteTest(item._id)" x-small
            >Удалить</v-btn
          >
        </template>
      </v-data-table>
    </template>
    <template v-else>
      <div class="d-flex flex-column">
        <span class="headline">Вы не создавали тестов!</span>
        <router-link to="/test/create">Создать тест</router-link>
      </div>
    </template>
  </v-container>
</template>
<script>
import { copyTextToClipboard } from "@/utils/functions";
import { mapState, mapActions } from "vuex";
export default {
  name: "Student",
  computed: {
    ...mapState("teacher", ["tests"])
  },
  data: () => ({
    headers: [
      {
        value: "name",
        text: "Название теста"
      },
      {
        value: "author",
        text: "Автор"
      },
      {
        value: "link",
        text: ""
      },
      {
        value: "result",
        text: ""
      },
      {
        value: "edit",
        text: ""
      },
      {
        value: "delete",
        text: ""
      }
    ]
  }),
  methods: {
    ...mapActions(["setMessageText"]),
    ...mapActions("teacher", ["deleteTestById", "loadTests"]),
    editTest(_id) {
      this.$router.push(`/test/list/${_id}`);
    },
    async deleteTest(_id) {
      const res = await this.deleteTestById({ _id });

      if (!res.err) {
        await this.loadTests();
        this.$store.dispatch("setMessageText", {
          text: "Вы успешно удалали тест!",
          type: "success"
        });
      } else {
        this.$store.dispatch("setMessageText", {
          text: res.err,
          type: "error"
        });
      }
    },
    async getLink(_id) {
      const { origin } = window.location;
     
        
        copyTextToClipboard(`${origin}/test/${_id}/pass`);
        if (navigator.clipboard) {
          this.setMessageText({
          text: "Ссылка скопирована в буфер обмена",
          type: "success"
        });
        }
      

      
    }
  }
};
</script>